VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private oServer As core.CServer
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal wIndx As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Private Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uiParam As Long, pvParam As Any, ByVal fWinIni As Long) As Long

Const SPI_SETDESKWALLPAPER = 20
Const SPIF_SENDWININICHANGE = &H2
Const SPIF_UPDATEINIFILE = &H1

Const WS_MINIMIZE = &H20000000  ' Style bit 'is minimized'
Const HWND_TOP = 0              ' Move to top of z-order
Const SWP_NOSIZE = &H1          ' Do not re-size window
Const SWP_NOMOVE = &H2          ' Do not reposition window
Const SWP_SHOWWINDOW = &H40     ' Make window visible/active
Const GW_HWNDFIRST = 0          ' Get first Window handle
Const GW_HWNDNEXT = 2           ' Get next window handle
Const GWL_STYLE = (-16)         ' Get Window's style bits
Const SW_RESTORE = 9            ' Restore window

Private Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type

Const WS_VISIBLE = &H10000000      ' Window is not hidden
Const WS_BORDER = &H800000         ' Window has a border

Dim curwindow As Long
Dim screenWidth As Long
Dim screenHeight As Long
Private m_sName As String
Private dtop As Long
Dim numdesks As Long
Public Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim r As RECT
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang Name, "!vwmnext"
    oServer.RegisterBang Name, "!vwmprev"
    oServer.RegisterBang Name, "!vwmgather"
    m_sName = Name
    
    numdesks = oServer.evalNum(oServer.GetKey(Name, "numdesks"))
    If numdesks = 0 Then
        numdesks = 4
    End If
    
    dtop = GetDesktopWindow
    GetWindowRect dtop, r
    dtop = FindWindow(CLng(0), "core")
   
    screenHeight = r.bottom
    screenWidth = r.right
    IBasePlugin_StartPlugin = 0
    
End Function
Private Sub IBasePlugin_StopPlugin()

    gather
    
End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

    Select Case Name
    Case "!vwmnext"
        If curwindow < numdesks - 1 Then
            switchdesk curwindow + 1
        Else
            switchdesk 0
        End If
    Case "!vwmprev"
        If curwindow > 0 Then
            switchdesk curwindow - 1
        Else
            switchdesk numdesks - 1
        End If
    Case "!vwmgather"
        gather
    End Select
   
End Sub
Private Sub gather()

    Dim r As RECT
    Dim hwcurr As Long
    
    hwcurr = GetWindow(dtop, GW_HWNDFIRST)
    Do While hwcurr
      If TaskWindow(hwcurr) Then
        GetWindowRect hwcurr, r
        If r.left > screenWidth Then
            r.left = r.left Mod screenWidth
            r.right = r.right Mod screenWidth
        End If
        If r.top > screenHeight Then
            r.top = r.top Mod screenHeight
            r.bottom = r.bottom Mod screenHeight
        End If
        If r.left < 0 Then
            r.left = r.left Mod screenWidth
            r.left = r.left + screenWidth
            r.right = r.right Mod screenWidth
            r.right = r.right + screenWidth
        End If
        If r.top < 0 Then
            r.top = r.top Mod screenHeight
            r.top = r.top + screenHeight
            r.bottom = r.bottom Mod screenHeight
            r.bottom = r.bottom + screenHeight
        End If
        MoveWindow hwcurr, r.left, r.top, r.right - r.left, r.bottom - r.top, True
      End If
      hwcurr = GetWindow(hwcurr, GW_HWNDNEXT)
    Loop

End Sub
Private Sub switchdesk(num As Integer)

    Dim r As RECT
    Dim hwcurr As Long
    Dim addV As Long
    Dim bg As String
    
    If num <> curwindow Then
        addV = (num - curwindow) * screenWidth
    End If

    hwcurr = GetWindow(dtop, GW_HWNDFIRST)
    Do While hwcurr
      If TaskWindow(hwcurr) Then
        GetWindowRect hwcurr, r
        r.left = r.left - addV
        r.right = r.right - addV
        MoveWindow hwcurr, r.left, r.top, r.right - r.left, r.bottom - r.top, True
      End If
      hwcurr = GetWindow(hwcurr, GW_HWNDNEXT)
    Loop
    bg = oServer.GetKey(m_sName, "background" & num)
    If bg <> "" Then
        SystemParametersInfo SPI_SETDESKWALLPAPER, 0, ByVal bg, SPIF_SENDWININICHANGE Or SPIF_UPDATEINIFILE
    End If
    curwindow = num

End Sub
Function TaskWindow(hwcurr As Long) As Long
    
    Dim lngStyle As Long
    
    lngStyle = GetWindowLong(hwcurr, GWL_STYLE)
    If (lngStyle And (WS_VISIBLE Or WS_BORDER)) = (WS_VISIBLE Or WS_BORDER) Then TaskWindow = True

End Function
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property

Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
